<template>
  <div class="container-main" ref="main">
    <div class="search-hearder" ref="topSearch">
      <el-form
        :model="queryParams"
        ref="queryForm"
        :inline="true"
        v-show="showSearch"
        label-width="auto"
      >
        <el-form-item label="媒体类型" prop="mediaType">
          <el-select
            v-model="queryParams.mediaType"
            placeholder="请选择媒体类型"
            clearable
            size="small"
          >
            <el-option
              v-for="dict in dict.type.tc_yq_media"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="涉事类型" prop="eventType">
          <el-select
            v-model="queryParams.eventType"
            placeholder="请选择涉事类型"
            clearable
            size="small"
          >
            <el-option
              v-for="dict in dict.type.tc_ss_type"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item>
          <el-button
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleQuery"
            >搜索</el-button
          >
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
            >重置</el-button
          >
        </el-form-item>
      </el-form>
    </div>
    <div class="layui-table-tool" ref="tableTool">
      <el-button
        type="primary"
        size="mini"
        @click="handleAdd()"
        v-hasPermi="['zongzhi:fl:add']"
        >新增</el-button
      >
      <el-button
        type="success"
        size="mini"
        :disabled="single"
        @click="handleUpdate"
        v-hasPermi="['zongzhi:fl:edit']"
        >修改</el-button
      >
      <el-button
        type="danger"
        size="mini"
        :disabled="multiple"
        @click="handleDelete"
        v-hasPermi="['zongzhi:fl:remove']"
        >删除</el-button
      >
      <el-button
        type="warning"
        size="mini"
        :loading="exportLoading"
        @click="handleExport"
        v-hasPermi="['zongzhi:fl:export']"
        >导出</el-button
      >
    </div>
    <el-table
      v-loading="loading"
      :data="flList"
      :height="tableHeigth"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="区域" align="center" prop="areaId">
        <template slot-scope="scope">
          {{ scope.row.areaId | filterTown }}
        </template>
      </el-table-column>
      <el-table-column label="媒体类型" align="center" prop="mediaType">
        <template slot-scope="scope">
          <dict-tag
            :options="dict.type.tc_yq_media"
            :value="scope.row.mediaType"
          />
        </template>
      </el-table-column>
      <el-table-column label="涉事类型" align="center" prop="eventType">
        <template slot-scope="scope">
          <dict-tag
            :options="dict.type.tc_ss_type"
            :value="scope.row.eventType"
          />
        </template>
      </el-table-column>
      <el-table-column label="媒体数据" align="center" prop="mediaCount" />
      <el-table-column label="涉事数量" align="center" prop="eventCount" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        width="200"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            @click="handleInfo(scope.row)"
            v-hasPermi="['zongzhi:fl:list']"
          >
            查看
          </el-button>
          <el-button
            type="success"
            size="mini"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['zongzhi:fl:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="danger"
            @click="handleDelete(scope.row)"
            v-hasPermi="['zongzhi:fl:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改舆情分类对话框 -->
    <el-dialog
      :visible.sync="open"
      width="500px"
      append-to-body
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ title }}</div>
      <el-form
        ref="form"
        :model="form"
        :rules="rules"
        label-width="auto"
        class="dialog-from"
      >
        <el-form-item label="区域" prop="areaId">
          <el-cascader
            v-model="form.areaId"
            :options="townList"
            :props="treeProps"
            clearable
          ></el-cascader>
        </el-form-item>
        <el-form-item label="媒体类型" prop="mediaType">
          <el-select v-model="form.mediaType" placeholder="请选择媒体类型">
            <el-option
              v-for="dict in dict.type.tc_yq_media"
              :key="dict.value"
              :label="dict.label"
              :value="parseInt(dict.value)"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="涉事类型" prop="eventType">
          <el-select v-model="form.eventType" placeholder="请选择涉事类型">
            <el-option
              v-for="dict in dict.type.tc_ss_type"
              :key="dict.value"
              :label="dict.label"
              :value="parseInt(dict.value)"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="媒体数据" prop="mediaCount">
          <el-input v-model="form.mediaCount" placeholder="请输入媒体数据" />
        </el-form-item>
        <el-form-item label="涉事数量" prop="eventCount">
          <el-input v-model="form.eventCount" placeholder="请输入涉事数量" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!--查看舆情分类详情页-->
    <el-dialog
      :visible.sync="infoOpen"
      width="1200px"
      append-to-body
      :close-on-click-modal="false"
      :destroy-on-close="true"
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ infoTitle }}</div>

      <el-descriptions
        title="舆情分类"
        :column="2"
        border
        labelClassName="desLable"
      >
        <el-descriptions-item label="区域">{{
          form.areaId
        }}</el-descriptions-item>

        <el-descriptions-item label="媒体类型">
          <dict-tag :options="dict.type.tc_yq_media" :value="form.mediaType" />
        </el-descriptions-item>

        <el-descriptions-item label="涉事类型">
          <dict-tag :options="dict.type.tc_ss_type" :value="form.eventType" />
        </el-descriptions-item>

        <el-descriptions-item label="媒体数据">{{
          form.mediaCount
        }}</el-descriptions-item>

        <el-descriptions-item label="涉事数量">{{
          form.eventCount
        }}</el-descriptions-item>
      </el-descriptions>
    </el-dialog>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import {
  listFl,
  getFl,
  delFl,
  addFl,
  updateFl,
  exportFl,
} from "@/api/zongzhi/netWorkYq/yqfl/index.js";
export default {
  computed: {
    ...mapGetters(["townList", "treeProps"]),
  },
  name: "Fl",
  //注释字典
  dicts: ["tc_yq_media", "tc_ss_type"],
  data() {
    return {
      tableHeigth: 0,
      //查看详情
      infoOpen: false,
      //详情标题
      infoTitle: "",
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 舆情分类表格数据
      flList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        mediaType: null,

        eventType: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  filters: {
    filterTown(target) {
      if (target) {
        target = JSON.parse(target);
        if (target.length > 0 && Array.isArray(target)) {
          return target.join("、");
        } else {
          return "";
        }
      }
    },
  },
  created() {
    // //给表格一个固定值
    this.$nextTick(() => {
      this.tableHeigth =
        this.$refs.main.offsetHeight -
        (this.$refs.topSearch.offsetHeight +
          this.$refs.tableTool.offsetHeight) -
        46;
      this.getList();
    });
  },
  methods: {
    /** 查询舆情分类列表 */
    getList() {
      this.loading = true;
      listFl(this.queryParams).then((response) => {
        this.flList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,

        areaId: null,

        mediaType: null,

        eventType: null,

        mediaCount: null,

        eventCount: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /**查看按钮操作 */
    handleInfo(row) {
      this.reset();
      const id = row.id || this.ids;
      getFl(id).then((response) => {
        response.data.areaId = JSON.parse(response.data.areaId);
        if (
          response.data.areaId.length > 0 &&
          Array.isArray(response.data.areaId)
        ) {
          response.data.areaId = response.data.areaId.join("、");
        } else {
          response.data.areaId = "";
        }
        this.form = response.data;
        this.infoOpen = true;
        this.infoTitle = "查看舆情分类详情";
      });
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加舆情分类";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getFl(id).then((response) => {
        response.data.areaId = JSON.parse(response.data.areaId);

        this.form = response.data;
        this.open = true;
        this.title = "修改舆情分类";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          this.form.areaId = JSON.stringify(this.form.areaId);

          if (this.form.id != null) {
            updateFl(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addFl(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm(
        '是否确认删除舆情分类编号为"' + ids + '"的数据项?',
        "警告",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }
      )
        .then(function () {
          return delFl(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有舆情分类数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.download(
            "/zongzhi/fl/export",
            {
              ...this.queryParams,
            },
            "舆情分类_" + new Date().getTime() + ".xlsx"
          );
          this.exportLoading = false;
        })
        .catch(() => {});
    },
  },
};
</script>
